# 63. Unique Paths II

**<font color=red>难度:Medium<font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/unique-paths-ii/

> 内容描述

```
A robot is located at the top-left corner of a m x n grid (marked 'Start' in the diagram below).

The robot can only move either down or right at any point in time. The robot is trying to reach the bottom-right corner of the grid (marked 'Finish' in the diagram below).

Now consider if some obstacles are added to the grids. How many unique paths would there be?



An obstacle and empty space is marked as 1 and 0 respectively in the grid.

Note: m and n will be at most 100.

Example 1:

Input:
[
  [0,0,0],
  [0,1,0],
  [0,0,0]
]
Output: 2
Explanation:
There is one obstacle in the middle of the 3x3 grid above.
There are two ways to reach the bottom-right corner:
1. Right -> Right -> Down -> Down
2. Down -> Down -> Right -> Right

```


> 思路1

******- 时间复杂度: O(n^2)******- 空间复杂度: O(n^2)******

运用动态规划的思想，写出状态转移方程，d(i,j) = d(i + 1,j) + d(i,j + 1)，不过要注意边界值

```cpp
class Solution {
public:
    int uniquePathsWithObstacles(vector<vector<int>>& obstacleGrid) {
        int length1 = obstacleGrid.size(),length2 = obstacleGrid[0].size();
        long long dp[length1][length2];
        memset(dp,0,sizeof(dp));
        for(int i = length1 - 1;i >= 0;--i)
            for(int j = length2 - 1;j >= 0;--j)
            {
                if(!obstacleGrid[i][j])
                {
                    if(i == length1 - 1 && j == length2 - 1)
                    dp[i][j] = 1;
                else
                {
                    if(i == length1 - 1)
                        dp[i][j] = dp[i][j + 1];
                    else if(j == length2 - 1)
                        dp[i][j] = dp[i + 1][j];
                    else
                        dp[i][j] = dp[i][j + 1] + dp[i + 1][j];
                }
            }
        }
    return dp[0][0];
    }
};
```
