# 403. Frog Jump

**<font color=red>难度: hard</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/frog-jump

> 内容描述

```
A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.

Given a list of stones' positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.

If the frog's last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.

Note:

The number of stones is ≥ 2 and is < 1,100.
Each stone's position will be a non-negative integer < 231.
The first stone's position is always 0.
Example 1:

[0,1,3,5,6,8,12,17]

There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit.

Return true. The frog can jump to the last stone by jumping 
1 unit to the 2nd stone, then 2 units to the 3rd stone, then 
2 units to the 4th stone, then 3 units to the 6th stone, 
4 units to the 7th stone, and 5 units to the 8th stone.
Example 2:

[0,1,2,3,4,8,9,11]

Return false. There is no way to jump to the last stone as 
the gap between the 5th and 6th stone is too large.
```

## 解题方案

> 思路 1
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

* 关注点放在数据范围。

* 判断是否能够到达y点（因为问题就是到达最后一个点），需要两个条件：

  * 能够到达x点（x<y）
  * x点能够跳到y点

* 由于条件2需要前面一个点的跳动情况，所以这个题的子问题是

  `flag[x][y]=true`表示当青蛙能够跳到x，并且能够跳到y点

* 状态转移是

  假设`flag[x][y]=true`，枚举所有的z>y，如果`|(z-y) - (y-x)|<=1`，那么`flag[y][z]=true`

* 这里有个需要注意的优化点，可以固定y，枚举x<y，和z>y，这样对于每个y，只需要扫一遍点数组就可以成功执行转移

* 复杂度是o(n^2)

代码：

```java
class Solution {
    public boolean canCross(int[] stones) {
        int n = stones.length;

        if (stones[1] != 1) {
            return false;
        }

        boolean[][] flag = new boolean[n][n];
        for (int i = 0;i < n;i++) {
            for (int j = 0;j < n;j++) {
                flag[i][j] = false;
            }
        }

        flag[1][0] = true;

        for (int i = 1;i < n;i++) {
            int left = i - 1;
            int right = i + 1;

            while (left >= 0 && right < n) {
                while (left >= 0 && !flag[i][left]) left--;
                if (left >= 0) {
                    while (right < n && stones[right] - stones[i] <= stones[i] - stones[left] + 1) {
                        if (stones[right] - stones[i] == stones[i] - stones[left] - 1
                                || stones[right] - stones[i] == stones[i] - stones[left]
                                || stones[right] - stones[i] == stones[i] - stones[left] + 1) {
                            flag[right][i] = true;
                        }
                        right++;
                    }
                    left--;
                }
            }
        }

        for (int i = 0;i < n;i++) {
            if (flag[n - 1][i]) {
                return true;
            }
        }
        return false;
    }
}
```

