# 0005. Longest Palindromic Substring

**<font color=red>难度: Medium</font>**

## 刷题内容

> 原题连接

[https://leetcode-cn.com/problems/longest-palindromic-substring/](https://leetcode-cn.com/problems/longest-palindromic-substring/)

> 内容描述

给定一个字符串 `s`，找到 `s` 中最长的回文子串。你可以假设 `s` 的最大长度为 1000。

#### 示例1:
     
     输入: "babad"
     输出: "bab"
     注意: "aba" 也是一个有效答案。


#### 示例2:
     
     输入: "cbbd"
     输出: "bb"
     
     
#### 进阶:

如果你已经实现复杂度为 O(n) 的解法，尝试使用更为精妙的分治法求解。

## 解题方案

> 思路 
******- 时间复杂度: O(N)******- 空间复杂度: O(2N)******


解法DP

```javascript
/**
 * @param {string} s
 * @return {string}
 */
var longestPalindrome = function(s) {
  let len = s.length;
  if (len < 2) {
    return s;
  }
  
  dp = Array.from({length:len}).map(() => []);

// 初始化
  for (let i = 0; i < len; i++) {
    dp[i][i] = true;
  }
  
  let maxLen = 1;
  let start = 0;
  
  for (let j = 1; j < len; j++) {
    for (let i = 0; i < j; i++) {
      
      if (s[i] === s[j]) {
        if (j - i < 3) {
          dp[i][j] = true;
        } else {
          dp[i][j] = dp[i + 1][j - 1];
        }
      } else {
        dp[i][j] = false;
      }
      
      if (dp[i][j]) {
        let curLen = j - i + 1;
        if (curLen > maxLen) {
          maxLen = curLen;
          start = i;
        }
      }
    }
  }
  return s.substring(start, start + maxLen)
};
```

