# 0198. House Robber

**<font color=green>难度: Easy</font>**

## 刷题内容

> 原题连接

* [https://leetcode-cn.com/problems/house-robber/](https://leetcode-cn.com/problems/house-robber/)

> 内容描述

你是一个专业的小偷，计划偷窃沿街的房屋。每间房内都藏有一定的现金，影响你偷窃的唯一制约因素就是相邻的房屋装有相互连通的防盗系统，**如果两间相邻的房屋在同一晚上被小偷闯入，系统会自动报警**。

给定一个代表每个房屋存放金额的非负整数数组，计算你**在不触动警报装置的情况下**，能够偷窃到的最高金额。

示例 1:

     输入: [1,2,3,1]
     输出: 4
     解释: 偷窃 1 号房屋 (金额 = 1) ，然后偷窃 3 号房屋 (金额 = 3)。
          偷窃到的最高金额 = 1 + 3 = 4 。
     
     
示例 2:

     输入: [2,7,9,3,1]
     输出: 12
     解释: 偷窃 1 号房屋 (金额 = 2), 偷窃 3 号房屋 (金额 = 9)，接着偷窃 5 号房屋 (金额 = 1)。
          偷窃到的最高金额 = 2 + 9 + 1 = 12 。
     

## 解题方案

> 思路 
******- 时间复杂度: O(N)******- 空间复杂度: O(N)******

DP动态规划

一次循环，循环到每个房间时都做一个选择：偷？还是不偷？

 * 偷：那么当前最大的收益（`DP[i]`） 为 `DP[i-2] + Vi`,其中为`Vi`代表当前房间的价值
 * 不偷：那么当前最大的收益（`DP[i]`）为`DP[i-1]`
 
 所以`DP[i] = Max(DP[i-2] + Vi, DP[i-1]) `

代码：

```javascript
/**
 * @param {number[]} nums
 * @return {number}
 */
var rob = function(nums) {
  let dp = []
  if(!nums.length) {
      return 0
  }
  nums.forEach((n, i) => {
    dp[i] = Math.max((dp[i-2] || 0) + n, (dp[i-1] || 0))
  })
  return dp[nums.length - 1]
};
```
