# 1130. Minimum Cost Tree From Leaf Values

**<font color=orange>难度: Medium</font>**

## 刷题内容

> 原题连接

* https://leetcode-cn.com/problems/minimum-cost-tree-from-leaf-values/

> 内容描述

给你一个正整数数组 arr，考虑所有满足以下条件的二叉树：

每个节点都有 0 个或是 2 个子节点。
数组 arr 中的值与树的中序遍历中每个叶节点的值一一对应。（知识回顾：如果一个节点有 0 个子节点，那么该节点为叶节点。）
每个非叶节点的值等于其左子树和右子树中叶节点的最大值的乘积。
在所有这样的二叉树中，返回每个非叶节点的值的最小可能总和。这个和的值是一个 32 位整数。

**示例 1：**

```
输入：arr = [6,2,4]
输出：32
解释：
有两种可能的树，第一种的非叶节点的总和为 36，第二种非叶节点的总和为 32。

    24            24
   /  \          /  \
  12   4        6    8
 /  \               / \
6    2             2   4
```

 **提示：**

- `2 <= arr.length <= 40`
- `1 <= arr[i] <= 15`
- 答案保证是一个 32 位带符号整数，即小于 `2^31`。

## 解题方案

> 思路 
> **- 时间复杂度: O(N)** 
>
> **- 空间复杂度: O(N)**

> 执行用时 :**60 ms**, 在所有 javascript 提交中击败了**92.86%**的用户
>
> 内存消耗 :**33.5 MB**, 在所有 javascript 提交中击败了**100.00%**的用户

代码：

```javascript
/**
 * @param {number[]} arr
 * @return {number}
 */
var mctFromLeafValues = function(arr) {
  if (!arr.length || arr.length < 2) {
    return 0
  }
  let res = 0;
  let stack = [];
  stack.unshift(Number.MAX_VALUE);
  arr.forEach(num => {
    while (stack[0] <= num) {
      let mid = stack.shift()
      res += mid * Math.min(stack[0], num);
    }
    stack.unshift(num);
  })
  
  while (stack.length > 2) {
    res += stack.shift() * stack[0]
  }
  return res;
};
```

