#  121. Best Time to Buy and Sell Stock

**<font color=green>难度: Easy</font>**

## 刷题内容

> 原题连接

* https://leetcode.com/problems/best-time-to-buy-and-sell-stock
* https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock

> 内容描述

```
给定一个数组，它的第 i 个元素是一支给定股票第 i 天的价格。

如果你最多只允许完成一笔交易（即买入和卖出一支股票一次），设计一个算法来计算你所能获取的最大利润。

注意：你不能在买入股票前卖出股票。

示例 1:

输入: [7,1,5,3,6,4]
输出: 5
解释: 在第 2 天（股票价格 = 1）的时候买入，在第 5 天（股票价格 = 6）的时候卖出，最大利润 = 6-1 = 5 。
     注意利润不能是 7-1 = 6, 因为卖出价格需要大于买入价格；同时，你不能在买入前卖出股票。

示例 2:

输入: [7,6,4,3,1]
输出: 0
解释: 在这种情况下, 没有交易完成, 所以最大利润为 0。
```

## 解题方案

> 思路1

1. 找到一个最低价格的位置，记录 index
2. 找到一个最大卖出价格的位置，记录 利润

```py
class Solution:
    def maxProfit(self, prices):
        n = len(prices)
        if n == 0: return 0

        result = 0
        minprice = prices[0]
        for i in range(1, n):
            minprice = min(prices[i], minprice)
            result = max(prices[i] - minprice, result)
        return result
```

> 思路2

1. 初始化 dp，用于存放目录结果
2. 找到最小值，计算当前最大的利润，存放到 dp中
3. 找到 dp 以后一个元素，就是当前结果的最大值

```py
class Solution:
    def maxProfit(self, prices):
        n = len(prices)
        if n == 0: return 0

        dp = [0] * n
        minprice = prices[0] 
        for i in range(1, n):
            # 找到最小的值
            minprice = min(minprice, prices[i])
            dp[i] = max(dp[i - 1], prices[i] - minprice)

        return dp[-1]
```



